package com.ruoyi.bgt.service;

import com.ruoyi.bgt.bo.BgtProjectTaskProgressQueryBo;
import com.ruoyi.bgt.domain.BgtProjectTaskProgress;
import com.ruoyi.bgt.domain.dto.BgtProjectTaskProgressQueryDTO;
import com.ruoyi.bgt.domain.vo.BgtProjectTaskProgressDetailVO;
import com.ruoyi.bgt.domain.vo.BgtProjectTaskProgressVO;
import com.ruoyi.common.core.mybatisplus.core.IServicePlus;
import com.ruoyi.common.core.page.TableDataInfo;

import java.util.Collection;
import java.util.List;

/**
 * 包工头项目任务进度Service接口
 *
 * @author ruoyi
 * @date 2025-02-18
 */
public interface IBgtProjectTaskProgressService extends IServicePlus<BgtProjectTaskProgress> {
    /**
     * 查询单个
     * @return
     */
    BgtProjectTaskProgress queryById(Long id);

    /**
     * 查询列表
     */
    TableDataInfo<BgtProjectTaskProgress> queryPageList(BgtProjectTaskProgressQueryBo bo);

    /**
     * 查询列表
     */
    List<BgtProjectTaskProgress> queryList(BgtProjectTaskProgressQueryBo bo);

    /**
     * 根据新增业务对象插入包工头项目任务进度
     * @param bo 包工头项目任务进度新增业务对象
     * @return
     */
    Boolean insert(BgtProjectTaskProgress bo);

    /**
     * 根据编辑业务对象修改包工头项目任务进度
     * @param bo 包工头项目任务进度编辑业务对象
     * @return
     */
    Boolean update(BgtProjectTaskProgress bo);

    /**
     * 校验并删除数据
     * @param ids 主键集合
     * @param isValid 是否校验,true-删除前校验,false-不校验
     * @return
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

	/**
	 * 查询列表
	 */
	TableDataInfo<BgtProjectTaskProgressVO> appQueryPageList(BgtProjectTaskProgressQueryDTO dto);

	/**
	 * app查询单个
	 */
	BgtProjectTaskProgressDetailVO appQueryById(Long id);

	/**
	 * 获取最新项目进度
	 */
	Integer getLastProgress(Long taskId);
}
